%
%Prolog file not FLEX (.pl)
%

%
%-----------------------------------------
%Main (startup) method.
%-----------------------------------------
%
betray(RuleSet,Fired) :-	% Indicate a rule set choosing characters behaviors.
   new_slot(signatures,daves_thesis,[]),
   betrayal_p(B),!,     		%Match the formalism with the extension of the KB. Create the frame.
   tell_story(B),
   runSim(RuleSet,Fired),	%Simulate with given rule set to determine outcome and produce dialog
   successful(B),		%Determine if outcome of theme was 'successful'
   nl,nl.

%
%-----------------------------------------
%Run the Simulation
%-----------------------------------------
%
runSim(RuleSet,Fired) :- 
   remove_facts,
   enable_rules,
   nl,
   %RuleSets don't seem to be working a BUG?
   %
   Rs = [edBehavior1,selmerBehavior1, membersBehavior, edBehavior2, selmerBehavior2b],
   forward_chain(fcfs,       	%Selection Algorithm
                 mf,        		 %Action if a rule's Action Fails
                 fail,      		 %Termination Condition
                 back,      	 %Agenda Update Algorithm
                 Rs,    		%Initial Agenda
                 Fired),    		 %Set of Rules Fired
   nl.

mf(Name) :-
	write('Rule has misfired ' -  Name), nl.

%----------------------------------------------------
% Execute an Action Frame
%
% Used to execute a program (code) 
% associated with an action frame.
%
%----------------------------------------------------
executeAction(Action) :-
   lookup(code,Action,P),
   P(Action).

executeBetrayal(B) :-
    lookup(betrayors_evil_action,B,Twrt),
    executeAction(Trwt).




%-----------------------------------------
% Given the instantiated stage build the
%  betrayal frame.
%-----------------------------------------
create_a_betrayal(Br,Bd,Gd,Lie,Twrt,B) :-
   gensym('betrayal_',B),
   new_instance(B,betrayal),
   new_slot(betrayed,B,Bd),
   new_slot(betrayor,B,Br),
   new_slot(betrayeds_goal,B,Gd),
   new_slot(betrayors_lie,B,Lie),
   new_slot(betrayors_evil_action,B,Twrt).


