
speak(Action,Tense) :-
    ancestor(Action,action),!,
    lookup(Tense,Action,S),
    lookup(theme,Action,Pointer),
    dereference(Pointer,Object),
    writeseq([S,Object]).

speak(Utterance) :-
    ancestor(Utterance,utterance),!,
    lookup(statement,Utterance,S),
    writenl(S).

speak(Goal) :-
    isa_instance(Goal,goal),!,
    write(Goal).

speak(Subject,(Verb,Person_Tense),Object_Phrase) :-
    lookup(Person_Tense,Verb,Verb_Word),
    writeseq([Subject, Verb_Word, Object_Phrase]),
    write('. ').

narrate(S,Verb,Tense,OP,Reason) :-
  nl,
  VP = (Verb, Tense),
  speak(S,VP,OP),
  writeseq(['It was',Reason]),
  write('. '),
  nl.

