/* ************************************************************

  Story-Level Production
	(Simple Story Grammar Implementation)

Modifed: 5/18/1999

************************************************************** */


%------------------------------------------------------------------
% Tell Story about Betrayal 
%
%	Introduction
%	Describe Betrayed's Goal
%	Descrive Betrayer's Promise
%	Describe Betrayer's Plan To Thwart Betrayed's Goal
%
%------------------------------------------------------------------
tell_story(ThematicFrame) :-
	TF = ThematicFrame,
	isa_instance(TF,betrayal),
	produce_stage_for_betrayal(TF,Bd,Br,BdsGoal,Lie,EvilAction,Setting),
 
	nl, pp_sentence([Bd,'s','Betrayal']), nl,

	introduce(Bd,Setting),  %Story Structure Variability Here! Can have random selection.
	describe_betrayeds_goal(Bd,BdsGoal),
	describe_betrayers_promise(Br,Bd,Lie),
	describe_betrayers_plan(Br,Bd,BdsGoal,EvilAction).
	
%------------------------------------------------------------------
%------------------------------------------------------------------
produce_stage_for_betrayal(Betrayal,Bd,Br,BdsGoal,Lie,EvilAction,Setting) :-
	lookup(betrayed,Betrayal,Bd),
	lookup(betrayor,B,Br),
  	lookup(name,Bd,MainCharName),
	lookup(betrayeds_goal,Betrayal,BdsGoal),
	lookup(location,BdsGoal,Setting),
	lookup(betrayors_lie,Betrayal,Lie),
	lookup(betrayors_evil_action,Betrayal,EvilAction).
	
%------------------------------------------------------------------
% Introduce the Setting and Main Character
%------------------------------------------------------------------
introduce(Person,Setting) :-
   %As in intro describe setting from Betrayed's POV.
   %	
   dspov(Setting,Person,love,present,Sentences).


%------------------------------------------------------------------
% Describe the Betrayed's Desire/Goal and
%   Specific Requirement to Achieve Goal
%------------------------------------------------------------------
describe_betrayeds_goal(Bd,Goal) :-
	describePersonsGoal(Bd,Goal,past,Sentence),
	pp_sentence(Sentence).
	

%------------------------------------------------------------------
% Describe the Betrayers Promise
%------------------------------------------------------------------
describe_betrayers_promise(Br,Bd,Lie) :-
	writeseqnl([Br, 'told',Bd]),
   	speak(Lie).


%------------------------------------------------------------------
% Describe the Betrayers Secret Plan
%------------------------------------------------------------------
describe_betrayers_plan(Br,Bd,Gd,Twrt) :-
	pp_openning_phrase([Br,'actually intends to thwart', Bd,'`s plans to',Gd]),
   	write('by '), 
   	speak(Twrt,presentPerfect),   write('.').
		



%-----------------------------------------
% Describe the Act of False Promise
%
% Action Sequence:
%     Bd reveals goal to Br
%     Br promies to assist
%-----------------------------------------
speakBetrayal(Br,Bd,Gd,Lie,Twrt) :-
   nl,   nl,
   write([Bd,'wants desperately to',Gd,'.']),nl,
   write(['While',Br, 'told',Bd]),nl,
   write('     '),
   speak(Lie),
   writeseqnl([Br,'actually intends to thwart',
                         Bd,'`s plans to',Gd]),
   write('by '), 
   speak(Twrt,presentPerfect),   write('.'),
    nl,   nl.


/* Under Construction

THIS WONT WORK until I reconcile competing methods for choosing and conjugating
verb vs actions frames. See action_frames.ksl and sentence_frames.ksl


%Example: (selmer,[stand,'in defiance'],'sick thirst for control and power',
%	['A sadistic ego','him to betrayal']

describe_betrayers_final_act(Br,FinalAct,Comment,Motivation) :-
	FinalAct = [Verb, Object_Phrase],
	simpleSentence(Br,Verb,past3,Object_Phrase,Sent1),
	pp_sentence(Sent1),
	simpleSentence(it,be,past3,Comment,Sent2),
	pp_sentence(Sent2),
	choose_verb(motivator, MotivateVerb), %TOCONSIDER: Maybe choose action then choose verb
	Motivation = [MotivatingReason, MotivatedActPhrase],
	writeseq([MotivatingReason, MotivateVerb, past3, MotivatedActPhrase,Sent3]),nl,
	simpleSentence(MotivatingReason, MotivateVerb, past3, MotivatedActPhrase,Sent3),
	pp_sentence(Sent3).
	

*/

